#pragma once

#include "Enum.h"

#include "GdiPlusWrapper.h"
#include "ntray.h"
#include "ConfigDlg.h"
#include "afxwin.h"
#include "afxcmn.h"
#include "ChatDlg.h"
#include "LoginDlg.h"
#include "SkinDialog.h"
#include "AboutDlg.h"
#include "RecvMemoDlg.h"
#include "MemoSendDlg.h"
#include "ProfileDlgController.h"
#include "CallHistoryDlg.h"
#include "AutoTextConfigDlg.h"
#include "IdleMonitor.h"
#include "MailModel.h"
#include "SettingFrame.hpp"
#include "AboutWnd.hpp"
#include "LanuageActorEvent.h"
#include "ModalDialogCloser.h"

#define DEF_MIN_SIZE_WIDTH			(350)
#define DEF_MIN_SIZE_HEIGHT			(560)

class WorkGroupController;
extern CComModule _Module;
class CPeriodicEventHandler;
class CProfileDlgController;
class CMailModel;
class MainFrame;
//class CCallerInfoDlg;

typedef struct TINY_SERVER_MSG
{
	CString strMsgType;
	CString strUserID;
	CString strNoteData;

	TINY_SERVER_MSG()
	{
		strMsgType = L"";
		strUserID = L"";
		strNoteData = L"";
	}

}TINY_SERVER_MSG;

typedef struct RETRY_RECVNOTE_INFO
{
	UINT64 noteID;
	int	   nReTryCount;
	
}RETRY_RECVNOTE_INFO;


const unsigned int WM_TI_TASKBARCREATED = ::RegisterWindowMessage(_T("TaskBarCreated"));

class CMyKey
{
public:
        std::string m_key;		

        // map Ű Ǳ ؼ  ڰ ʿ
        // const member function  ʿ
        bool operator<(const CMyKey& other) const
        {
                return m_key.c_str()[0] < other.m_key.c_str()[0];
        };

        // constructor
        //CMyKey(const char* key){ m_key = key;};
		CMyKey(const int key){ m_key = key;};
};

#define WM_LOGOUT  (WM_USER) + 75648

// CNeMessengerDlg ȭ 
class CNeMessengerDlg : public CSkinDialog, 
	private IGTWASActorEvent, 
	private IGTMessengerActorEvent,
	private CAMSWnd,
	private CAMSWnd::PlacementHook,
    public CModalDialogMgr     //close the modal dialog
{
// Դϴ.
public:
	CNeMessengerDlg(CWnd* pParent = NULL);	
	virtual ~CNeMessengerDlg();

	enum { IDD = IDD_NEMESSENGER_DIALOG };	

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	


// Դϴ.
protected:
	HICON			m_hIcon;
	BOOL			m_bTopMost;					//ֻ 
	BOOL			m_bLogin;					//α 	
	BOOL			m_bRetryLoginWithInterval;
	UINT			m_nRetryLoginInterval;
	//int				m_nSendMemo;				// ° ޸â.
	CTrayNotifyIcon	m_TrayIcon;
	int				m_nHotkeyAltMID;			//alt+m Ű  Ű ̵
	BOOL			m_bRequestPhoneStatus;
	BOOL			m_isCheckingUpdate;
	CPeriodicEventHandler* m_pPeriodicEventHandler;

	CCriticalSection m_csSetStatus;

	WorkGroupController	*m_pWorkGroupController;	
	CProfileDlgController *m_pProfileDlgController;
	CConfigDlg		m_ConfigDlg;
	CSettingFrame   *m_pDlgSetting;
	CAboutWnd		*m_pAboutWnd;
	CLoginDlg		m_LoginDlg;
	UINT			_clipBoardFormat;
	CAutoTextConfigDlg	m_AutoTextConfigDlg;

	CLanuageActorEvent *m_pLanuageActorEvent;
	MainFrame		*m_pFrame;
	BOOL			m_bRestore;

	//  ޽  Լ
	virtual BOOL OnInitDialog();

	void RegisterPeriodicEventThread();

	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();

public:
	DWORD m_noteHandle;
	CIdleMonitor *m_IdleMonitor;

	DECLARE_MESSAGE_MAP()
public:	
	afx_msg LRESULT OnPopupTrayDlg(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnTrayNotification(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnExitChatDlg(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnExitSendMemoDlg(WPARAM wParam, LPARAM lParam);	
	afx_msg LRESULT OnExitRecvMemoDlg(WPARAM wParam, LPARAM lParam);	
	afx_msg LRESULT OnNTalkDeInitialize(WPARAM wPram, LPARAM lParam);
	afx_msg void OnTopMenuLogout();
	afx_msg void OnTopMenuAlwaysTop();
	afx_msg void OnTopMenuMyInfo();
	afx_msg void DoInfoItemNote();
    afx_msg void DoOpenWebNote();

	afx_msg void OnTopMenuExit();
	afx_msg void OnTopMenuChat();
	afx_msg void OnTopMenuSMS();
	afx_msg void OnTopMenuMakeCall();
	afx_msg void OnTopMenuAnswerCall();
	afx_msg void OnTopMenuClearConnection();
	afx_msg void OnTopMenuHoldCall();
	afx_msg void OnTopMenuRetrieveCall();
	afx_msg void OnTopMenuForwarding();
	afx_msg void OnTopMenuCallTransfer();
	afx_msg void OnTopMenuDoNotDisturbTrue();
	afx_msg void OnTopMenuDoNotDisturbFalse();
	afx_msg void OnTopMenuConferenceCall();
	afx_msg void OnTopMenuSendMemo();
	afx_msg void OnTopMenuViewOrganizationChart();
	afx_msg void OnTopMenuViewWorkGroup();
	afx_msg void OnTopMenuDel();
	afx_msg void OnTopMenuMakeGroup();
	afx_msg void OnTopMenuRenameGroup();
	afx_msg void OnTopMenuDelGroup();
	afx_msg void OnTopMenuManageMemo();
	afx_msg void OnTopMenuManageConfig();
	afx_msg void OnTopMenuManageAutoText();
	afx_msg void OnTopMenuOpenDownloadFolder();
	afx_msg void OnTopMenuManageCall();
	afx_msg void OnTopMenuAbout();
	afx_msg void OnTopMenuHelpNeMessenger();
	afx_msg void OnTopMenuFavoriteCopy(UINT nCmdID);
	afx_msg void OnTopMenuFavoriteMove(UINT nCmdID);
	afx_msg void OnTopMenuImportGroup();
	afx_msg void OnChatHistory();
	afx_msg LRESULT OnDesktopIdle(WPARAM wParam,LPARAM lParam);
	afx_msg LRESULT OnTinyServerMessage(WPARAM wParam,LPARAM lParam);
	virtual BOOL PreTranslateMessage(MSG* pMsg);	
	afx_msg void OnDestroy();
	afx_msg void OnMove(int x, int y);

	void UnRegisterPeriodicEventThread();
	LRESULT OnCloseSettingFrame(WPARAM wParam,LPARAM lParam);
	LRESULT OnRestartApp(WPARAM wParam,LPARAM lParam);
	LRESULT OnTrayChangeStatus(WPARAM wParam,LPARAM lParam);
	LRESULT OnNTalkNotifyVersion(WPARAM wParam,LPARAM lParam);
	BOOL	UserGivenRect(LPRECT lpRect);
	void	SetWindowMax();
	BOOL	IsJustSavePosition();
	afx_msg void OnUpdate();
	afx_msg void OnTraySetting();
	afx_msg void OnTrayLogin();
	afx_msg void OnTrayLogout();
	afx_msg void OnTrayOpen();
	afx_msg void OnTrayExit();

	// Callback handler for the taskbar created event
	LRESULT OnTaskBarCreated(WPARAM wParam, LPARAM lParam);

	void LoadOrganization(ORGVIEWTYPE eViewType, CWnd *pParent=NULL);

	
	bool			ProcLogin(CString strId, CString strPw);	
	int				ProcRenameTalkname(CString strTalkname);	
	int				ProcRenameGroupName(int nCurGroupID, CString strNewGroupname);
	bool			ProcGroupSort(std::vector<GT_BUDDY_GROUP_DATA>& vecGroupData);
	bool			ProcChangeMyStatus(GTUserStatusType type);
	bool			ProcTotalUsedCapa();
	bool			ProcListNotice();
	bool			ProcGetHanatourCount();
	bool			ProcListOutLink();
	bool			ProcRefreshTicket();
	bool			ProcChatMyRoomList();
	bool			ProcUnreadNoteCnt();
	bool			ProcPhoneCall(CString strUserID, CString strPhoneNum);
	//bool			ProcPhoneConferenceCall(CString strUserID, CString strPhoneNum);
	
	bool			RetryLogin();
	void			RetryLoginWithInterval(UINT nInterval);
	void			DisableWindows(BOOL bStatus);
	void			LogOut();
	bool			IsLogin();
	void			ResotoreLoginWindow();
	BOOL			IsAMSWndZoomed();
	void			RequestLogoutWithoutClosingWindows(GTLogoutReasonType reason);
	bool			IsRetryLoginWithInterval();
	bool			IsNonAuthorizedUser();

	bool			IsCloseMsg(MSG* pMsg);
	bool			IsExistNode(HTREEITEM hDrag,HTREEITEM hDrop);

    //call this to notify chat room user changed -- call when chat dialog close
    bool            BeginUpdateAllChatUsersInRoomList();
    bool            UpdateAllChatUsersInRoomList(const chatroomlist_t& chatUsers);
    bool            EndUpdateAllChatUsersInRoomList();

	CString			GetLoginErrorMessage(GT_LOGIN_ERROR_DATA sError);	

	int DivideString(CString _strData, CString _strIndex, CStringArray* _arrData);
	int DivideString(CString _strData, CString _strIndex, std::vector<std::wstring> &vecUsers);

	int DownloadFile(LPCTSTR pszURL, LPCTSTR pszDest);	

	WorkGroupController* GetWorkGroupController() { return m_pWorkGroupController; }	
	void SetWorkGroupController(WorkGroupController* pValue) { m_pWorkGroupController = pValue; }	
	CProfileDlgController* GetProfileDlgController() { return m_pProfileDlgController; }
	void SetProfileDlgController(CProfileDlgController* pValue) { m_pProfileDlgController = pValue; }

	CConfigDlg&		GetConfigDlg() { return m_ConfigDlg; }
	CLoginDlg&		GetLoginDlg() { return m_LoginDlg; }
	MainFrame*		GetMainFrame(){return m_pFrame;}
	CLanuageActorEvent* GetLanuageActorEvent() { return m_pLanuageActorEvent; }

	void			SetDND();
	BOOL			IsTopMost(){ return m_bTopMost;}
	void			SetTopMost(BOOL bTopMost){ m_bTopMost = bTopMost;}

protected:
	virtual bool	OnGTMessengerActor_UpdateState(IGTMessengerActor *pActor, GTMessengerActorState state);		
	virtual bool	OnGTMessengerActor_ResponseBuddyAction(IGTMessengerActor *pActor, const GT_BUDDY_RESULT_DATA& sData);
	virtual bool	OnGTMessengerActor_ResponseUserImage(IGTMessengerActor *pActor, const GT_USER_IMAGE_RESULT_DATA& sData);
	virtual bool	OnGTMessengerActor_UpdateBuddyStatus(IGTMessengerActor *pActor, LPCWSTR strBuddyID, int nTypeBits);
	virtual bool	OnGTMessengerActor_UpdateNotBuddyUserStatus(IGTMessengerActor *pActor, LPCWSTR strBuddyID, int nUserStatus, LPCWSTR strNick, int nIPTStatus, int nFlag);
	virtual bool	OnGTMessengerActor_ResponseBuddyGroupAction(IGTMessengerActor *pActor, const GT_BUDDY_GROUP_RESULT_DATA& sData, GTBuddyAddGroupType addGroupType);
	virtual bool	OnGTMessengerActor_UpdateMyStatus(IGTMessengerActor *pActor, BYTE flag, GTUserStatusType presence, NTIPTStatusType iptPrev, NTIPTStatusType iptCur);
	virtual bool	OnGTMessengerActor_UpdateMyTalkName(IGTMessengerActor *pActor, LPCWSTR strTalkName);
	virtual bool	OnGTMessengerActor_NotifyRecvChatInvite(IGTMessengerActor *pActor, const GT_MEMO_DATA& sData);
	virtual bool	OnGTMessengerActor_NotifySystemMessage(IGTMessengerActor *pActor,  const ChangeNoticePushData &chageNotice);
	//virtual bool	OnGTMessengerActor_ResponseUpdateGroupOrder( IGTMessengerActor *pActor, trid_t trid, vector<GT_BUDDY_GROUP_DATA> &vecBuddyGroupData);

	virtual bool	OnGTMessengerActor_NotifyIPTCallInfo( IGTMessengerActor *pActor, LPCWSTR strUserID, LPCWSTR strTelNo, LPCWSTR strCID );
	virtual bool	OnGTMessengerActor_ResponsePhoneCall( IGTMessengerActor *pActor, BYTE result, LPCWSTR strCID );
	virtual bool	OnGTMessengerActor_ResponseForwardingInfo(IGTMessengerActor *pActor, BYTE ret, BYTE act, LPCWSTR strTelNo);
	virtual bool	OnGTMessengerActor_ResponseIptResult(IGTMessengerActor *pActor, BYTE ret, UINT cmd);
	virtual bool	OnGTMessengerActor_ResponseDndInfo(IGTMessengerActor *pActor, BYTE ret, BYTE act);

	virtual bool	OnGTMessengerActor_ResponseRefreshWorkStatus(IGTMessengerActor *pActor, trid_t trid, vector<GT_BUDDY_WORK_STATUS_DATA> &vecWorkStatusData);

	virtual bool	OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID);
	virtual bool	OnGTWASActor_ResponseSetUserProfile(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const GT_USER_PROFILE_DATA &sInfo);
	virtual bool	OnGTWASActor_ResponseCheckUserIdentify(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const GT_CHECK_USER_IDENTITY_ERROR_DATA &sInfo);
	virtual bool	OnGTWASActor_ResponseGetTotalUsedCapa(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const GT_GET_TOTAL_USED_CAPA_DATA &sData);
	virtual bool	OnGTWASActor_ResponseNoticeList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const std::vector<NE_NOTICE_DATA> &listNoticeData);
	virtual bool	OnGTWASActor_ResponseBannerList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const std::vector<NE_BANNER_DATA> &listBannerData);
	virtual bool	OnGTWASActor_ResponseGetHanatourCount(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const std::vector<NE_HANATOUR_COUNT> &listHanatourCount);
	virtual bool	OnGTWASActor_ResponseOutLinkList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const std::vector<NE_OUTLINK_DATA> &listOutLinkData);
	virtual bool	OnGTWASActor_ResponseRefreshTicket(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, LPCWSTR strSession);
	virtual bool	OnGTWASActor_ResponseGetMyRoomList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const std::vector<NE_MYROOM_DATA> &listMyRoom);
	virtual bool	OnGTWASActor_ResponseUnreadNoteCount(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, int nUnreadNoteCount);
	virtual bool	OnGTWASActor_ResponseRecvNoteInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode,const NoteInfo &noteInfo, NTReqNoteInfoType reqType, UINT64 noteID);
	virtual bool	OnGTMessengerActor_GetBuddyStatusNotify(IGTMessengerActor *pActor, std::map<WSTRING, BYTE> &m_mapBuddyInfo);

	virtual bool	OnGTMessengerActor_ResponseUpdateGroupOrder(IGTMessengerActor *pActor, trid_t trid,vector<GT_BUDDY_GROUP_DATA> &vecBuddyGroupData); 
	void			EncryptIdandPasswordToSaveLocal();
	void			NTalkDeInitialize();
	void			InitLoginSuccess();
	void			LoadFunctionList();
	void			ChangeNoticeView();
	void			UpdateNoticeView();
	bool			IsLogOutMsg(MSG* pMsg);

	virtual bool	OnGTMessengerActor_NotifyRecvNote(IGTMessengerActor *pActor, const ULONGLONG& lNoteId, const LPCWSTR strFromID, const LPCWSTR strFromName, const ULONG &nUnreadNoteCnt);
	virtual bool	OnGTMessengerActor_NotifyRecvUnreadNoteCnt(IGTMessengerActor *pActor, const ULONG& lUnreadCnt);
	virtual bool	OnGTWASActor_ResponseMailCount(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, NTNMailErrorCode eNMailError, const INT64 ulPrevMailSN, const INT64 ulMailCountData);
	virtual bool	OnGTWASActor_ResponseMailPreview(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, LPCWSTR strSubject, LPCWSTR strContent, LPCWSTR strSenderName, LPCWSTR strSenderID);
	virtual bool	OnGTWASActor_ResponseSetCallInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, int nCallSeq);
	virtual bool OnGTWASActor_ResponseNameSearchList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_SEARCH_MEMBER_DATA_LIST &list);
	const CString	GetNoteInfo( long lNoteId ); 

public:
	void ChangeFavoriteStatusIcon(IGTMessengerActor *pActor,HTREEITEM hItem, LPCWSTR strBuddyID);			//03.02
	static int __cdecl ItemComareFunc(void *pvlocale,const void *elem1, const void *elem2);

public:
	afx_msg void OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct);

	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);

	afx_msg void OnNMSendMemo();

	afx_msg LRESULT OnMenuChar(UINT nChar, UINT nFlags, CMenu* pMenu);

	void __ResourceLoad(BOOL bInit = FALSE);
	
	BOOL DeInitialize();      			
	afx_msg void OnBnClickedSearchButton();
	afx_msg BOOL OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct);

	afx_msg LRESULT OnMemoTrayPopup(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnMemoTrayPopupFocus(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnNoteDlgMax(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnBuddyOnlineTrayPopup(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT	OnMailTrayPopup(WPARAM wParam, LPARAM lParam);
	
	void CloseModalDlg(BOOL bExceptConfigDlg = FALSE);
	void CloseChildAll();
	CString GetFilterName(CString strDisplayName,int Optflag);				
	afx_msg void OnHotKey(UINT nHotKeyId, UINT nKey1, UINT nKey2);	
	std::vector<NE_NOTICE_DATA> listNoticeData_Dummy;
	NE_NOTICE_DATA notice1;
	NE_NOTICE_DATA notice2;
	NE_NOTICE_DATA notice3;

	std::vector<NE_OUTLINK_DATA> listOutlinkData_Dummy;
	std::map<size_t, NE_OUTLINK_DATA> mapOutlinkData_Dummy;
	NE_OUTLINK_DATA outlink1;
	NE_OUTLINK_DATA outlink2;
	NE_OUTLINK_DATA outlink3;
	NE_OUTLINK_DATA outlink4;
	NE_OUTLINK_DATA outlink5;
	afx_msg UINT OnPowerBroadcast(UINT nPowerEvent, LPARAM nEventData);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnEndSession(BOOL bEnding);
	afx_msg void OnSessionChange(UINT nSessionState, UINT nId);

	void AdjustUserStatus( UINT nSessionState );
	void CloseCallHistoryDlg();
	//void CloseCallerInfoDlg();

	void OpenChatHistoryDlg(CString UserID);
	CString GetUpdateNoticeURL();

private:
	CMailModel *m_pMailModel;
	CRect m_rcWindowBeforeLogOut;
	CRect m_rcWindowMaxRestore;
	bool m_bWindowZoomedBeforeLogOut;
	CCallHistoryDlg *m_pCallHistoryDlg;
	CTime m_lagacyCountLoadTime;
	//CCallerInfoDlg *m_pCallerInfoDlg;
	BOOL m_bUpdateStatus;
	std::list<trid_t>	m_tridListRecvNoteInfo;
	std::vector<RETRY_RECVNOTE_INFO> m_vecRecvNoteRetryInfo;
	std::map<trid_t, CString>	m_tridMapIPTSearch;
	NE_SEARCH_MEMBER_PARAM m_searchParam;
	void RetryRecvNoteInfo( UINT64 noteID );
	void DeleteRetryRecvNoteInfo( UINT64 noteID );
    LPCTSTR _GetActorStateString(GTMessengerActorState state);

    typedef std::set<WSTRING> ChatUsersInRoomListContainer;
    ChatUsersInRoomListContainer   m_AllChatUsersInRoomList; //maintain user for POI
    ChatUsersInRoomListContainer   m_OldChatUsersInRoomList; //compare with all, so can identify whether changed

///////////////////////////////////////////////////////////////////////////////
// IPT - 丵 
///////////////////////////////////////////////////////////////////////////////
protected:
	CString			m_strCID;
	BYTE			m_nForwardingStatus;
	CString			m_strRequestedFwdTelNo;	// ȯ  û ȣ.   m_strCurrentFwdTelNo  .
	BYTE			m_nDndStatus;
	BYTE			m_nHoldStatus;
	NE_CALL_DATA	m_sCallData;			// ȭ ̷ 
	trid_t			m_tridCallerInfo;


public:
	void SetCID(LPCWSTR strCID);
	CString GetCID();

	void SetForwardingInfo( BYTE nForwarding, LPCWSTR strTelNo );
	void SetForwardingStatus( BYTE nForwarding );
	BYTE GetForwardingStatus();
	BOOL IsAvailableUpdateStatus(){return m_bUpdateStatus;}
	void SetDND(BYTE nDndStatus);
	BYTE GetDND();

	void SetHold(BYTE nHoldStatus);
	BYTE GetHold();

	void SetCallSeqForCallData(int nCallSeq) { m_sCallData.nCallSeq = nCallSeq; }
	afx_msg void OnClose();
};
